---------
function GoGo_OnLoad()
---------
	SLASH_GOGOMOUNT1 = "/gogo"
	SlashCmdList["GOGOMOUNT"] = function(msg) GoGo_OnSlash(msg) end
	SLASH_GOGOID1 = "/id"
	SlashCmdList["GOGOID"] = function(msg) GoGo_Msg(GoGo_Id(msg)) end
	this:RegisterEvent("VARIABLES_LOADED")
	this:RegisterEvent("UPDATE_BINDINGS")
	this:RegisterEvent("TAXIMAP_OPENED")
	this:RegisterEvent("CHAT_MSG_ADDON")
end --function

---------
function GoGo_OnEvent(event)
---------
	if event == "VARIABLES_LOADED" then
		TESTVERSION = false
		GOGO_DEBUG = false
		if not GoGo_Prefs then
			GoGo_Prefs = {}
			GoGo_Settings_Default()
		end --if
		if GoGo_Prefs.autodismount then
			this:RegisterEvent("UI_ERROR_MESSAGE")
		end --if
		_, GOGO_CLASS = UnitClass("player")
		if (GOGO_CLASS == "DRUID" or GOGO_CLASS == "SHAMAN") then
			this:RegisterEvent("PLAYER_REGEN_DISABLED")
			GoGoFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
			GoGoFrame:SetScript("OnUpdate", GoGo_CheckMoving)
		end --if
		GOGO_OUTLANDS = table.concat({GetMapZones(3)}, ":")..":"..GOGO_ZONE_TWISTING_NETHER
		GOGO_NORTHREND = table.concat({GetMapZones(4)}, ":")
		if not GoGo_Prefs.version or GoGo_Prefs.version ~= GetAddOnMetadata("GoGoMount", "Version") then
			GoGo_Settings_Default()
		end --if
		GoGo_Settings_Update()
	elseif event == "PLAYER_REGEN_DISABLED" then
		for i, button in ipairs({GoGoButton, GoGoButton2}) do
			if GoGo_Prefs.useshapeform then
				if GOGO_CLASS == "SHAMAN" then
					GoGo_FillButton(button, GoGo_InBook(GOGO_SPELLS["SHAMAN"]))
				elseif GOGO_CLASS == "DRUID" then
					GoGo_FillButton(button, GoGo_InBook(GOGO_SPELLS["DRUID"]))
				end --if
			else
				GoGo_FillButton(button)
			end --if
		end --for
	elseif event == "ZONE_CHANGED_NEW_AREA" then
		SetMapToCurrentZone()
	elseif event == "TAXIMAP_OPENED" then
		GoGo_Dismount()
	elseif event == "UPDATE_BINDINGS" then
		GoGo_CheckBindings()
	elseif event == "UI_ERROR_MESSAGE" then
		if GOGO_ERRORS[arg1] and not IsFlying() then
			GoGo_Dismount()
		end --if
	elseif (event == "CHAT_MSG_ADDON") and (arg1 == "GoGoMountVER") and not GoGo_Prefs.DisableUpdateNotice then
		if (arg2 > GetAddOnMetadata("GoGoMount", "Version")) and not GoGoShownUpdate then
			GoGoShownUpdate = true
			GoGo_Msg("GoGoMount update is available and is being used by "..arg4)
		end --if
	end --if
end --function

---------
function GoGo_OnSlash(msg)
---------
	if GOGO_COMMANDS[string.lower(msg)] then
		GOGO_COMMANDS[string.lower(msg)]()
	elseif GoGo_InCompanions(msg) then
		GoGo_AddPrefMount(GoGo_InCompanions(msg))
		GoGo_Msg("pref")
	elseif GoGo_InBook(msg) then
		GoGo_AddPrefSpell(msg)
		GoGo_Msg("pref")
	else
		GoGo_Msg("shapeform")
		GoGo_Msg("auto")
		GoGo_Msg("fly")
		GoGo_Msg("genericfastflyer")
		GoGo_Msg("updatenotice")
		GoGo_Msg("mountnotice")
		if GOGO_CLASS == "DRUID" then GoGo_Msg("druidclickform") end --if
		GoGo_Msg("pref")
	end --if
end --function

---------
function GoGo_PreClick(button)
---------
	if GOGO_DEBUG then
		DEFAULT_CHAT_FRAME:AddMessage(GoGo_Msg("GoGo PreClick Runs"))
		DEFAULT_CHAT_FRAME:AddMessage(GoGo_Msg("Location = " .. GetRealZoneText() .. " - " .. GetZoneText() .. " - " ..GetSubZoneText() .. " - " .. GetMinimapZoneText()))
	end --if

	if not InCombatLockdown() then
		GoGo_FillButton(button)
	end --if

	if IsMounted() then
		GoGo_Dismount()
	elseif GOGO_CLASS == "DRUID" and GoGo_IsShifted() and not InCombatLockdown() then
		GoGo_Dismount(button)
	elseif GOGO_CLASS == "SHAMAN" and UnitBuff("player", GOGO_SHAMAN_GHOSTWOLF) then
		GoGo_Dismount()
	elseif not InCombatLockdown() then
		GoGo_FillButton(button, GoGo_ChooseMount())
	end --if
	
	if not TESTVERSION then
		if ( IsInGuild() ) then
			SendAddonMessage("GoGoMountVER", GetAddOnMetadata("GoGoMount", "Version"), "GUILD")
		end --if
			SendAddonMessage("GoGoMountVER", GetAddOnMetadata("GoGoMount", "Version"), "BATTLEGROUND")
			SendAddonMessage("GoGoMountVER", GetAddOnMetadata("GoGoMount", "Version"), "RAID")
	end --if
	
end --function

---------
function GoGo_ChooseMount()
---------
	if (GOGO_CLASS == "DRUID") and (GoGo_IsMoving or IsSwimming()) then
		return GoGo_InBook(GOGO_SPELLS["DRUID"])
	elseif (GOGO_CLASS == "SHAMAN") and (GoGo_IsMoving or IsSwimming()) then
		return GoGo_InBook(GOGO_SPELLS["SHAMAN"])
	end --if

	local mounts = {}
	local GoGo_FilteredMounts = {}
	local loc = GetRealZoneText()
	
	if (table.getn(mounts) == 0) then
		if GoGo_Prefs[loc] then
			mounts = GoGo_Prefs[loc]
		end --if
	end --if

	if (table.getn(mounts) == 0) then
		GoGo_FilteredMounts = GoGo_MountList()
		if not GoGo_FilteredMounts or (table.getn(GoGo_FilteredMounts) == 0) then
			if GOGO_CLASS == "SHAMAN" and GoGo_Prefs.useshapeform then
				if GOGO_DEBUG then
					DEFAULT_CHAT_FRAME:AddMessage(GoGo_Msg("Using shaman wolf form - no mounts found."))
				end --if
				return GoGo_InBook(GOGO_SPELLS["SHAMAN"])
			elseif GOGO_CLASS == "DRUID" and GoGo_Prefs.useshapeform then
				return GOGO_SPELLS["DRUID"]
			else
				return nil
			end --if
		end --if
	end --if
	
	if (table.getn(mounts) == 0) then
		local GoGo_TempMounts = {}
		if not (GoGo_GetSkillLevel(GOGO_SKILL_ENGINEERING) == nil) and (GoGo_GetSkillLevel(GOGO_SKILL_ENGINEERING) <= 349) then
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 45)
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 46)
		elseif not (GoGo_GetSkillLevel(GOGO_SKILL_ENGINEERING) == nil) and (GoGo_GetSkillLevel(GOGO_SKILL_ENGINEERING) >= 350) and (GoGo_GetSkillLevel(GOGO_SKILL_ENGINEERING) <= 374) then
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 46)
		elseif not (GoGo_GetSkillLevel(GOGO_SKILL_ENGINEERING) == nil) and (GoGo_GetSkillLevel(GOGO_SKILL_ENGINEERING) >= 375) then
			-- filter nothing
		else
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 45)
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 46)
		end --if
		if not (GoGo_GetSkillLevel(GOGO_SKILL_TAILORING) == nil) and (GoGo_GetSkillLevel(GOGO_SKILL_TAILORING) <= 409) then
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 49)
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 48)
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 47)
		elseif not (GoGo_GetSkillLevel(GOGO_SKILL_TAILORING) == nil) and (GoGo_GetSkillLevel(GOGO_SKILL_TAILORING) >= 410) and (GoGo_GetSkillLevel(GOGO_SKILL_TAILORING) <= 424) then
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 49)
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 47)
		elseif not (GoGo_GetSkillLevel(GOGO_SKILL_TAILORING) == nil) and (GoGo_GetSkillLevel(GOGO_SKILL_TAILORING) >= 425) and (GoGo_GetSkillLevel(GOGO_SKILL_TAILORING) <= 449) then
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 47)
		elseif not (GoGo_GetSkillLevel(GOGO_SKILL_TAILORING) == nil) and (GoGo_GetSkillLevel(GOGO_SKILL_TAILORING) >= 450) then
			-- filter nothing
		else
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 49)
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 48)
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 47)
		end --if

		if loc == GOGO_ZONE_DALARAN then
			local GoGo_SubZone = GetSubZoneText()
			if not (GoGo_SubZone == GOGO_SZONE_KRASUSLANDING) then -- and not (GetSubZoneText() == "The Floating Stones") then
				GoGo_SkipFlying = true
			end --if
		end --if
		if loc == GOGO_ZONE_WINTERGRASP then
			GoGo_SkipFlying = true
		end --if

		if loc == GOGO_ZONE_AQ40 then
			mounts = GoGo_FilterMountsIn(GoGo_FilteredMounts, 51)
		else
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 50)
		end --if
	end --if

	if (table.getn(mounts) == 0) and GoGo_CanFly() and not GoGo_SkipFlying and (GoGo_InOutlands() or (GoGo_InNorthrend() and GoGo_InBook(GOGO_COLD_WEATHER_FLYING))) then
		if not (GoGo_GetSkillLevel(GOGO_SKILL_RIDING) == nil) and (GoGo_GetSkillLevel(GOGO_SKILL_RIDING)) <= 224 then
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 36)
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 35)
		elseif not (GoGo_GetSkillLevel(GOGO_SKILL_RIDING) == nil) and (GoGo_GetSkillLevel(GOGO_SKILL_RIDING) >= 225) and (GoGo_GetSkillLevel(GOGO_SKILL_RIDING) <= 299) then
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 35)
		elseif not (GoGo_GetSkillLevel(GOGO_SKILL_RIDING) == nil) and (GoGo_GetSkillLevel(GOGO_SKILL_RIDING) >= 300) then
			-- filter nothing
		else
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 36)
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 35)
		end --if
		if GoGo_Prefs.useshapeform and GoGo_InBook(GOGO_DRUID_FAST_FLIGHTFORM) and GOGO_CLASS == "DRUID" then
			table.insert(mounts, GOGO_DRUID_FAST_FLIGHTFORM)
		end --if
		if (table.getn(mounts) == 0) and (GOGO_CLASS == "DRUID") and (GoGo_InBook(GOGO_DRUID_FLIGHTFORM)) and (GoGo_Prefs.useshapeform) then
			table.insert(mounts, GOGO_DRUID_FLIGHTFORM)
		end --if

		if (table.getn(mounts) == 0) then
			GoGo_TempMounts = GoGo_FilterMountsIn(GoGo_FilteredMounts, 1)
			mounts = GoGo_FilterMountsIn(GoGo_TempMounts, 24)
		end --if
		if GoGo_Prefs.genericfastflyer then
			local GoGo_TempMountsA = GoGo_FilterMountsIn(GoGo_TempMounts, 23)
			if not (GoGo_GetSkillLevel(GOGO_SKILL_RIDING) == nil) and (GoGo_GetSkillLevel(GOGO_SKILL_RIDING) <= 299) then
				GoGo_TempMountsA = GoGo_FilterMountsOut(GoGo_TempMountsA, 29)
			end --if
			if GoGo_TempMountsA then
				for counter = 1, table.getn(GoGo_TempMountsA) do
					table.insert(mounts, GoGo_TempMountsA[counter])
				end --for
			end --if
			local GoGo_TempMountsA = GoGo_FilterMountsIn(GoGo_TempMounts, 26)
			if GoGo_TempMountsA then
				for counter = 1, table.getn(GoGo_TempMountsA) do
					table.insert(mounts, GoGo_TempMountsA[counter])
				end --for
			end --if
		end --if
		if (table.getn(mounts) == 0) then
			GoGo_TempMountsA = GoGo_FilterMountsIn(GoGo_TempMounts, 23)
			if not (GoGo_GetSkillLevel(GOGO_SKILL_RIDING) == nil) and (GoGo_GetSkillLevel(GOGO_SKILL_RIDING) <= 299) then
				mounts = GoGo_FilterMountsOut(GoGo_TempMountsA, 29)
			else
				mounts = GoGo_TempMountsA
			end --if
--			if (GOGO_CLASS == "DRUID") and (GoGo_InBook(GOGO_DRUID_FAST_FLIGHTFORM)) and (GoGo_Prefs.useshapeform) then
--				table.insert(mounts, GOGO_DRUID_FAST_FLIGHTFORM)
--			end --if
		end --if
		if (table.getn(mounts) == 0) and GoGo_Prefs.preferflight then
			GoGo_TempMounts = GoGo_FilterMountsIn(GoGo_FilteredMounts, 1)
			mounts = GoGo_FilterMountsIn(GoGo_TempMounts, 20)
--			if (GOGO_CLASS == "Druid") and (GoGo_InBook(GOGO_DRUID_FLIGHTFORM)) and (GoGo_Prefs.useshapeform) then
--				table.insert(GoGo_TempMounts, GOGO_DRUID_FLIGHTFORM)
--			end --if
		end --if
	end --if

	if (table.getn(GoGo_FilteredMounts) >= 1) then
		--GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 1)
		GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 36)
		GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 35)
	end --if
	
	if (table.getn(mounts) == 0) and GoGo_CanRide() then
		if not (GoGo_GetSkillLevel(GOGO_SKILL_RIDING) == nil) and (GoGo_GetSkillLevel(GOGO_SKILL_RIDING) <= 74) then
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 37)
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 38)
		elseif not (GoGo_GetSkillLevel(GOGO_SKILL_RIDING) == nil) and (GoGo_GetSkillLevel(GOGO_SKILL_RIDING) >= 75) and (GoGo_GetSkillLevel(GOGO_SKILL_RIDING) <= 149) then
			GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 37)
		end --if
		GoGo_TempMountsA = GoGo_FilterMountsIn(GoGo_FilteredMounts, 21)
		if not (GoGo_GetSkillLevel(GOGO_SKILL_RIDING) == nil) and (GoGo_GetSkillLevel(GOGO_SKILL_RIDING) <= 149) then
			mounts = GoGo_FilterMountsOut(GoGo_TempMountsA, 29)
		else
			mounts = GoGo_TempMountsA
		end --if
		if (table.getn(mounts) == 0) then
			mounts = GoGo_FilterMountsIn(GoGo_FilteredMounts, 20)
		end --if
		if (table.getn(mounts) == 0) then
			mounts = GoGo_FilterMountsIn(GoGo_FilteredMounts, 25)
		end --if
	end --if
	
	if table.getn(GoGo_FilteredMounts) >= 1 then
		GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 37)
		GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 38)
		GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 21)
		GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 20)
		GoGo_FilteredMounts = GoGo_FilterMountsOut(GoGo_FilteredMounts, 25)
	end --if
	
	if (table.getn(mounts) == 0) then
		if (GOGO_CLASS == "SHAMAN") and (GoGo_InBook(GOGO_SHAMAN_GHOSTWOLF)) and (GoGo_Prefs.useshapeform) then
			table.insert(mounts, GOGO_SHAMAN_GHOSTWOLF)
		end --if
	end --if

	if (table.getn(mounts) >= 1) then
		if GOGO_DEBUG then
			for a = 1, table.getn(mounts) do
				DEFAULT_CHAT_FRAME:AddMessage(GoGo_Msg("Random picks from " .. mounts[a]))
			end --for
		end --if
		local selected = {}
		selected = mounts[math.random(table.getn(mounts))]
		if type(selected) == "string" then
			return selected
		else
			local GoGo_TempMounts = {}
			table.insert(GoGo_TempMounts, selected)
			if (table.getn(GoGo_FilterMountsIn(GoGo_TempMounts, 4)) == 1) then
				selected = GetItemInfo(selected)
			else
				selected = GetSpellInfo(selected)
			end --if
			return selected
		end --if
	end --if
			
end --function

---------
function GoGo_FilterMountsOut(PlayerMounts, FilterID)
---------
	local GoGo_FilteringMounts = {}
	if table.getn(PlayerMounts) == 0 then
		return GoGo_FilteringMounts
	end --if
	for a = 1, table.getn(PlayerMounts) do
		local MountID = PlayerMounts[a]
		for DBMountID, DBMountData in pairs(GoGo_Mounts) do
			if (DBMountID == MountID) and not DBMountData[FilterID] then
				table.insert(GoGo_FilteringMounts, MountID)
			elseif not GoGo_Mounts[MountID] then
				GoGo_Prefs.UnknownMounts[MountID] = true
				if not GoGo_Prefs.DisableMountNotice and not GoGo_DisableUnknownMountNotice then
					GoGo_DisableUnknownMountNotice = true
					GoGo_Msg("UnknownMount")
				end --if
			end --if
		end --for
	end --for
	return GoGo_FilteringMounts
end --function

---------
function GoGo_FilterMountsIn(PlayerMounts, FilterID)
---------
	local GoGo_FilteringMounts = {}
	if table.getn(PlayerMounts) == 0 then
		return GoGo_FilteringMounts
	end --if
	for a = 1, table.getn(PlayerMounts) do
		local MountID = PlayerMounts[a]
		for DBMountID, DBMountData in pairs(GoGo_Mounts) do
			if (DBMountID == MountID) and DBMountData[FilterID] then
				table.insert(GoGo_FilteringMounts, MountID)
			elseif not GoGo_Mounts[MountID] then
				GoGo_Prefs.UnknownMounts[MountID] = true
				if not GoGo_Prefs.DisableMountNotice and not GoGo_DisableUnknownMountNotice then
					GoGo_DisableUnknownMountNotice = true
					GoGo_Msg("UnknownMount")
				end --if
			end --if
		end --for
	end --for
	return GoGo_FilteringMounts
end --function

---------
function GoGo_Dismount(button)
---------
	if IsMounted() then
		Dismount()
	elseif GOGO_CLASS == "DRUID" and GoGo_IsShifted() and button then
		if GoGo_Prefs.DruidClickForm then
			GoGo_FillButton(button, GoGo_ChooseMount())
		else
--			CancelUnitBuff("player", GoGo_IsShifted())  -- protected by blizzard now
			GoGo_FillButton(button, GoGo_IsShifted())
		end --if
	elseif GOGO_CLASS == "SHAMAN" and UnitBuff("player", GoGo_InBook(GOGO_SHAMAN_GHOSTWOLF)) then
		CancelUnitBuff("player", GoGo_InBook(GOGO_SHAMAN_GHOSTWOLF))
	else
		return nil
	end --if
	return true
end --function

---------
function GoGo_InCompanions(item)
---------
	for slot = 1, GetNumCompanions("MOUNT") do
		local _, _, spellID = GetCompanionInfo("MOUNT", slot)
		if spellID and string.find(item, spellID) then
			if GOGO_DEBUG then 
				DEFAULT_CHAT_FRAME:AddMessage(GoGo_Msg("Found " .. GetSpellInfo(spellID)))
			end --if
			return GetSpellInfo(spellID)
		end --if
	end --for
end --function

---------
function GoGo_MountList()
---------
	local GoGo_FindingMounts = {}
	local GoGo_TempMounts = {}
	if (GetNumCompanions("MOUNT") >= 1) then
		for slot = 1, GetNumCompanions("MOUNT"),1 do
			local _, _, SpellID = GetCompanionInfo("MOUNT", slot)
			table.insert(GoGo_FindingMounts, SpellID)
		end --for
	end --if
	GoGo_TempMounts = GoGo_FilterMountsIn(GoGo_MountsItems, 4)
	
	for a = 1, table.getn(GoGo_TempMounts) do
		local MountID = GoGo_TempMounts[a]
		if GoGo_InBags(MountID) then
			table.insert(GoGo_FindingMounts, MountID)
		end --if
	end --for
	return GoGo_FindingMounts
end

---------
function GoGo_InBags(item)
---------
	for bag = 0, NUM_BAG_FRAMES do
		for slot = 1, GetContainerNumSlots(bag) do
			local link = GetContainerItemLink(bag, slot)
			if link and string.find(link, item) then
				return GetItemInfo(link)
			end --if
		end --for
	end --for
end --function

---------
function GoGo_InBook(spell)
---------
	if type(spell) == "function" then
		return spell()
	else
		if type(spell) == "string" then
			local spellname = spell
		elseif type(spell) == "number" then
			local spellname = GetSpellInfo(spell)
		end --if
		if GOGO_DEBUG then
			DEFAULT_CHAT_FRAME:AddMessage(GoGo_Msg("InBook searching for " .. spell))
		end --if
		local slot = 1
		while GetSpellName(slot, "spell") do
			local name = GetSpellName(slot, "spell")
			if name == spellname then
				return spellname
			end --if
			slot = slot + 1
		end --while
	end --if
end --function

---------
function GoGo_IsShifted()
---------
	if GOGO_DEBUG then
		DEFAULT_CHAT_FRAME:AddMessage(GoGo_Msg("Is shifted called"))
	end --if
	for i = 1, GetNumShapeshiftForms() do
		local _, name, active = GetShapeshiftFormInfo(i)
		if active then
			if GOGO_DEBUG then
				DEFAULT_CHAT_FRAME:AddMessage(GoGo_Msg("Is Shifted found " .. name))
			end --if
			return name
		end
	end --for
end --function

---------
function GoGo_InOutlands()
---------
	local loc = GetRealZoneText()
	if string.find(GOGO_OUTLANDS, loc, 1, true) then
		return true
	end --if
end --function

function GoGo_InNorthrend()
---------
	local loc = GetRealZoneText()
	if string.find(GOGO_NORTHREND, loc, 1, true) then
		return true
	end --if
end --function

---------
function GoGo_AddPrefMount(spell)
---------
	if GOGO_DEBUG then 
		DEFAULT_CHAT_FRAME:AddMessage(GoGo_Msg("Preference " .. spell))
	end --if

	local loc = GetRealZoneText()
	if not GoGo_Prefs[loc] then GoGo_Prefs[loc] = {} end
	table.insert(GoGo_Prefs[loc], spell)
	if table.getn(GoGo_Prefs[loc]) > 1 then
		local i = 2
		repeat
			if GoGo_Prefs[loc][i] == GoGo_Prefs[loc][i - 1] then
				table.remove(GoGo_Prefs[loc], i)
			else
				i = i + 1
			end --if
		until i > table.getn(GoGo_Prefs[loc])
	end --if
end --function

---------
--function GoGo_AddPrefSpell(spell)
---------
--	local loc = GetRealZoneText()
--	if not GoGo_Prefs[loc] then GoGo_Prefs[loc] = {} end
--	GoGo_Prefs[loc][GOGO_CLASS] = spell
--end --function

---------
function GoGo_FillButton(button, mount)
---------
	if mount then
		button:SetAttribute("macrotext", "/cast "..mount)
	else
		button:SetAttribute("macrotext", nil)
	end --if
end --function

---------
function GoGo_CheckBindings()
---------
	for binding, button in pairs({GOGOBINDING = GoGoButton, GOGOBINDING2 = GoGoButton2}) do
		ClearOverrideBindings(button)
		local key1, key2 = GetBindingKey(binding)
		if key1 then
			SetOverrideBindingClick(button, true, key1, button:GetName())
		end --if
		if key2 then
			SetOverrideBindingClick(button, true, key2, button:GetName())
		end --if
	end --if
end --function

---------
function GoGo_CanFly()
---------
	local level = UnitLevel("player")
	if level >=70 then
		return true
	elseif GOGO_CLASS == "DRUID" and level >= 68 then
		return true
	end --if
end --function

---------
function GoGo_CanRide()
---------
	local level = UnitLevel("player")
	if level >= 30 then
		return true
	end --if
end --function

---------
function GoGo_CheckMoving(time)
---------
	local pos = GetPlayerMapPosition("player")
	if pos ~= GoGo_Position then
		GoGo_Position = pos
		GoGo_IsMoving = true
	else
		GoGo_IsMoving = nil
	end --if
end --function

---------
function GoGo_GetSkillLevel(searchname)
---------
	for skillIndex = 1, GetNumSkillLines() do
		skillName, isHeader, isExpanded, skillRank = GetSkillLineInfo(skillIndex)
		if isHeader == nil then
			if skillName == searchname then
				return skillRank
			end --if
		end --if
	end --for
end --function

---------
function GoGo_Msg(msg)
---------
	if msg then
		if GOGO_MESSAGES[msg] then
			GoGo_Msg(GOGO_MESSAGES[msg]())
		else
			msg = string.gsub(msg, "<", LIGHTYELLOW_FONT_COLOR_CODE)
			msg = string.gsub(msg, ">", "|r")
			DEFAULT_CHAT_FRAME:AddMessage(GREEN_FONT_COLOR_CODE.."GoGo: |r"..msg)
		end --if
	end --if
end --function

---------
function GoGo_Id(itemstring)
---------
	local _, _, itemid = string.find(itemstring,"(item:%d+)")
	if itemid then
		return itemid.." - "..itemstring
	end --if
	local _, _, spellid = string.find(itemstring,"(spell:%d+)")
	if spellid then
		return spellid.." - "..itemstring
	end --if

end --function

GOGO_ERRORS = {
	[SPELL_FAILED_NOT_MOUNTED] = true,
	[SPELL_FAILED_NOT_SHAPESHIFT] = true,
	[ERR_ATTACK_MOUNTED] = true,
}

GOGO_SPELLS = {
	["DRUID"] = function()
		if GoGo_InBook(GOGO_DRUID_AQUAFORM) then
			if not GoGo_SkipFlying and (GoGo_InOutlands() or (GoGo_InNorthrend() and GoGo_InBook(GOGO_COLD_WEATHER_FLYING))) and GoGo_InBook(GOGO_DRUID_FAST_FLIGHTFORM) then
				return "[swimming] "..GoGo_InBook(GOGO_DRUID_AQUAFORM).."; [combat]"..GoGo_InBook(GOGO_DRUID_TRAVELFORM).."; "..GoGo_InBook(GOGO_DRUID_FAST_FLIGHTFORM)
			elseif not GoGo_SkipFlying and (GoGo_InOutlands() or (GoGo_InNorthrend() and GoGo_InBook(GOGO_COLD_WEATHER_FLYING))) and GoGo_InBook(GOGO_DRUID_FLIGHTFORM) then
				return "[swimming] "..GoGo_InBook(GOGO_DRUID_AQUAFORM).."; [combat]"..GoGo_InBook(GOGO_DRUID_TRAVELFORM).."; "..GoGo_InBook(GOGO_DRUID_FLIGHTFORM)
			else
				return "[swimming] "..GoGo_InBook(GOGO_DRUID_AQUAFORM).."; "..GoGo_InBook(GOGO_DRUID_TRAVELFORM)
			end --if
		end --if
	end, --function
	["SHAMAN"] = GOGO_SHAMAN_GHOSTWOLF,
}

GOGO_COMMANDS = {
	["shapeform"] = function()
		if (GOGO_CLASS == "DRUID") or (GOGO_CLASS == "SHAMAN") then
			GoGo_Prefs.useshapeform = not GoGo_Prefs.useshapeform
			GoGo_Msg("shapeform")
			GoGo_Settings_Update()
		else
			return
		end --if
	end, --function
	["auto"] = function()
		GoGo_Prefs.autodismount = not GoGo_Prefs.autodismount
		GoGo_Msg("auto")
		GoGo_Settings_Update()
	end, --function
	["fly"] = function()
		if not GoGo_CanFly() then
			return
		else
			GoGo_Prefs.preferflight = not GoGo_Prefs.preferflight
			GoGo_Msg("fly")
			GoGo_Settings_Update()
		end --if
	end, --function
	["genericfastflyer"] = function()
		if not GoGo_CanFly() then
			return
		else
			GoGo_Prefs.genericfastflyer = not GoGo_Prefs.genericfastflyer
			GoGo_Msg("genericfastflyer")
			GoGo_Settings_Update()
		end --if
	end, --function
	["clear"] = function()
		GoGo_Prefs[GetRealZoneText()] = nil
		if not InCombatLockdown() then
			for i, button in ipairs({GoGoButton, GoGoButton2}) do
				GoGo_FillButton(button)
			end --for
		end --if
		GoGo_Msg("pref")
	end, --function
	["updatenotice"] = function()
		GoGo_Prefs.DisableUpdateNotice = not GoGo_Prefs.DisableUpdateNotice
		GoGo_Msg("updatenotice")
		GoGo_Settings_Update()
	end, --function
	["mountnotice"] = function()
		GoGo_Prefs.DisableMountNotice = not GoGo_Prefs.DisableMountNotice
		GoGo_Msg("mountnotice")
		GoGo_Settings_Update()
	end, --function
	["druidclickform"] = function()
		GoGo_Prefs.DruidClickForm = not GoGo_Prefs.DruidClickForm
		GoGo_Msg("druidclickform")
		GoGo_Settings_Update()
	end, --function
}

GOGO_MESSAGES = {
	["shapeform"] = function()
		if (GOGO_CLASS == "DRUID") or (GOGO_CLASS == "SHAMAN") then
			if GoGo_Prefs.useshapeform then
				return "Shape forms included - </gogo shapeform> to toggle"
			else
				return "Shape forms excluded - </gogo shapeform> to toggle"
			end --if
		else
			return
		end --if
	end, --function
	["auto"] = function()
		if GoGo_Prefs.autodismount then
			return "Autodismount active - </gogo auto> to toggle"
		else
			return "Autodismount inactive - </gogo auto> to toggle"
		end --if
	end, --function
	["fly"] = function()
		if not GoGo_CanFly() then
			return
		elseif GoGo_Prefs.preferflight then
			return "Slow flying over fast running - </gogo fly> to toggle"
		else
			return "Fast running over slow flying - </gogo fly> to toggle"
		end --if
	end, --function
	["genericfastflyer"] = function()
		if not GoGo_CanFly() then
			return
		elseif GoGo_Prefs.genericfastflyer then
			return "Considering epic flying mounts 310%, 300% and 280% speeds the same for random selection - </gogo genericfastflyer> to toggle"
		else
			return "Considering epic flying mounts 310%, 300% and 280% speeds different for random selection - </gogo genericfastflyer> to toggle"
		end --if
	end, --function
	["pref"] = function()
		local loc = GetRealZoneText()
		local list = ""
		if GoGo_Prefs[loc] then
			list = list..table.concat(GoGo_Prefs[loc], ", ")
			if GoGo_Prefs[loc][GOGO_CLASS] then
				if string.len(list) > 0 then
					list = list..", "
				end --if
				list = list..GoGo_Prefs[loc][GOGO_CLASS]
			end --if
			return loc..": "..list.." - </gogo clear> to clear"
		else
			return loc..": ?".." - </gogo ItemLink> or </gogo SpellName> to add"
		end --if
	end, --function
	["updatenotice"] = function()
		if GoGo_Prefs.DisableUpdateNotice then
			return "Update notices from other players disabled - </gogo updatenotice> to toggle"
		else
			return "Update notices from other players enabled - </gogo updatenotice> to toggle"
		end --if
	end, --function
	["mountnotice"] = function()
		if GoGo_Prefs.DisableMountNotice then
			return "Update notices about unknown mounts are disabled - </gogo mountnotice> to toggle"
		else
			return "Update notices about unknown mounts are enabled - </gogo mountnotice> to toggle"
		end --if
	end, --function
	["druidclickform"] = function()
		if GoGo_Prefs.DruidClickForm then
			return "Single click form changes enabled - </gogo druidclickform> to toggle"
		else
			return "Single click form changes disabled - </gogo druidclickform> to toggle"
		end --if
	end, --function
	["UnknownMount"] = function() return "An unknown mount has been found in you list of mounts.  Please report this so that it can be added to future versions of GoGoMount." end --function
		
}

---------
function GoGo_Panel_OnLoad(GoGo_Panel)
---------
	GoGo_Panel.name = "GoGoMount"
	GoGo_Panel.okay = function (self) GoGo_Panel_Okay(); end;
	GoGo_Panel.default = function (self) GoGo_Settings_Default(); GoGo_Settings_Update(); end;
	InterfaceOptions_AddCategory(GoGo_Panel)
	
	GoGo_Panel_DruidClickForm = CreateFrame("CheckButton", "GoGo_Panel_DruidClickForm", GoGo_Panel, "OptionsCheckButtonTemplate")
	GoGo_Panel_DruidClickForm:SetPoint("TOPLEFT", 16, -16)
	GoGo_Panel_DruidClickFormText:SetText("Single click to shift from form to travel forms")

	GoGo_Panel_AutoDismount = CreateFrame("CheckButton", "GoGo_Panel_AutoDismount", GoGo_Panel, "OptionsCheckButtonTemplate")
	GoGo_Panel_AutoDismount:SetPoint("TOPLEFT", "GoGo_Panel_DruidClickForm", "BOTTOMLEFT", 0, -4)
	GoGo_Panel_AutoDismountText:SetText("Enable automatic dismount")

	if GoGo_CanFly() then
		GoGo_Panel_PreferFlight = CreateFrame("CheckButton", "GoGo_Panel_PreferFlight", GoGo_Panel, "OptionsCheckButtonTemplate")
		GoGo_Panel_PreferFlight:SetPoint("TOPLEFT", "GoGo_Panel_AutoDismount", "BOTTOMLEFT", 0, -4)
		GoGo_Panel_PreferFlightText:SetText("Prefer slow air mount over fast ground mount")

		GoGo_Panel_GenericFastFlyer = CreateFrame("CheckButton", "GoGo_Panel_GenericFastFlyer", GoGo_Panel, "OptionsCheckButtonTemplate")
		GoGo_Panel_GenericFastFlyer:SetPoint("TOPLEFT", "GoGo_Panel_PreferFlight", "BOTTOMLEFT", 0, -4)
		GoGo_Panel_GenericFastFlyerText:SetText("Consider 310%, 300% and 280% mounts the same speed")
	end --if

	GoGo_Panel_UseShapeFormSpells = CreateFrame("CheckButton", "GoGo_Panel_UseShapeFormSpells", GoGo_Panel, "OptionsCheckButtonTemplate")
	if GoGo_CanFly() then
		GoGo_Panel_UseShapeFormSpells:SetPoint("TOPLEFT", "GoGo_Panel_GenericFastFlyer", "BOTTOMLEFT", 0, -4)
	else
		GoGo_Panel_UseShapeFormSpells:SetPoint("TOPLEFT", "GoGo_Panel_AutoDismount", "BOTTOMLEFT", 0, -4)
	end --if
	GoGo_Panel_UseShapeFormSpellsText:SetText("Use shape shift forms\n(flight forms instead of flying mounts)")

	GoGo_Panel_DisableUpdateNotice = CreateFrame("CheckButton", "GoGo_Panel_DisableUpdateNotice", GoGo_Panel, "OptionsCheckButtonTemplate")
	GoGo_Panel_DisableUpdateNotice:SetPoint("TOPLEFT", "GoGo_Panel_UseShapeFormSpells", "BOTTOMLEFT", 0, -12)
	GoGo_Panel_DisableUpdateNoticeText:SetText("Disable update notices")

	GoGo_Panel_DisableMountNotice = CreateFrame("CheckButton", "GoGo_Panel_DisableMountNotice", GoGo_Panel, "OptionsCheckButtonTemplate")
	GoGo_Panel_DisableMountNotice:SetPoint("TOPLEFT", "GoGo_Panel_DisableUpdateNotice", "BOTTOMLEFT", 0, -4)
	GoGo_Panel_DisableMountNoticeText:SetText("Disable unknown mount notices")
	
end --function

---------
function GoGo_Settings_Update()
---------
	GoGo_Panel_UseShapeFormSpells:SetChecked(GoGo_Prefs.useshapeform)
	GoGo_Panel_AutoDismount:SetChecked(GoGo_Prefs.autodismount)
	if GoGo_CanFly() then
		GoGo_Panel_PreferFlight:SetChecked(GoGo_Prefs.preferflight)
		GoGo_Panel_GenericFastFlyer:SetChecked(GoGo_Prefs.genericfastflyer)
	end --if

	GoGo_Panel_DisableUpdateNotice:SetChecked(GoGo_Prefs.DisableUpdateNotice)
	GoGo_Panel_DisableMountNotice:SetChecked(GoGo_Prefs.DisableMountNotice)
	GoGo_Panel_DruidClickForm:SetChecked(GoGo_Prefs.DruidClickForm)

	if GoGo_Prefs.autodismount then
		GoGoFrame:RegisterEvent("UI_ERROR_MESSAGE")
	else
		GoGoFrame:UnregisterEvent("UI_ERROR_MESSAGE")
	end --if
end -- function

---------
function GoGo_Panel_Okay()
---------
	GoGo_Prefs.useshapeform = GoGo_Panel_UseShapeFormSpells:GetChecked()
	GoGo_Prefs.autodismount = GoGo_Panel_AutoDismount:GetChecked()
	if GoGo_CanFly() then
		GoGo_Prefs.preferflight = GoGo_Panel_PreferFlight:GetChecked()
		GoGo_Prefs.genericfastflyer = GoGo_Panel_GenericFastFlyer:GetChecked()
	end --if
	GoGo_Prefs.DisableUpdateNotice = GoGo_Panel_DisableUpdateNotice:GetChecked()
	GoGo_Prefs.DisableMountNotice = GoGo_Panel_DisableMountNotice:GetChecked()
	GoGo_Prefs.DruidClickForm = GoGo_Panel_DruidClickForm:GetChecked()
end --function

---------
function GoGo_Settings_Default()
---------
	GoGo_Prefs.version = GetAddOnMetadata("GoGoMount", "Version")
	GoGo_Prefs.useshapeform = true
	GoGo_Prefs.autodismount = true
	GoGo_Prefs.preferflight = true
	GoGo_Prefs.DisableUpdateNotice = false
	GoGo_Prefs.DisableMountNotice = false
	GoGo_Prefs.genericfastflyer = false
	GoGo_Prefs.DruidClickForm = true
	GoGo_Prefs.UnknownMounts = {}
end --function
